import os
import sys
import logging
import subprocess
import datetime
import os
import time
import signal
import re

pattern_asan_head = re.compile(r'==\d+==ERROR: AddressSanitizer:')
# pattern_asan_shadow = re.compile(r'Shadow bytes around the buggy address:')


def search_file(dirname):
    paths = []
    for root, dirs, files in os.walk(dirname):
        for file in files:
            print(file)
            if file.startswith("README"):
                continue
            else:
                path = os.path.join(root, file)
                paths.append(path)
    print(len(paths))
    return paths


def TIMEOUT_COMMAND(command, stdout, stderr):
    """call shell-command and either return its output or kill it
    if it doesn't normally exit within timeout seconds and return None"""
    process = subprocess.Popen(command, stdout=subprocess.PIPE, stderr=subprocess.PIPE, shell=True)
    outs, errs = process.communicate()
    stdout.write(outs)
    if pattern_asan_head.search(errs) is not None:
        stderr.write(errs)


def generation_command(target, parameter, paths, stdout_outputfile, stderr_outputfile):
    stdout_output = open(stdout_outputfile, "w+")
    stderr_output = open(stderr_outputfile, "w+")
    for path in paths:
        command = target + " " + parameter.replace("@@", path, 1) + " "
        print(command)
        TIMEOUT_COMMAND(command, stdout_output, stderr_output)


def main(argv):
    target = argv[0]
    cmd = "@@"
    dirname = argv[1]
    stdout_outputfile = argv[2]
    stderr_outputfile = argv[3]
    print("Searching files\n")
    paths = search_file(dirname)
    generation_command(target, cmd, paths, stdout_outputfile, stderr_outputfile)


if __name__ == "__main__":
    main(sys.argv[1:])
